<template>
  <div>
    <q-table
      class="data-table"
      :data="orderReports"
      :columns="columns"
      row-key="id"
      rows-per-page-label="Số dữ liệu trên 1 trang"
    >
      <template v-slot:top="props">
        <div class="text-h5">Báo cáo đơn hàng</div>
        <q-space />
        <q-input
          v-model="dateRange[0]"
          dense
          outline
          debounce="300"
          mask="##/##/####"
          placeholder="Từ ngày"
          class="q-mr-md"
          style="width: 120px"
          @input="onSelectDateRange"
        >
          <template v-slot:append>
            <q-icon name="event" class="cursor-pointer">
              <q-popup-proxy ref="qStartDateProxy" transition-show="scale" transition-hide="scale">
                <q-date
                  v-model="dateRange[0]"
                  mask="DD/MM/YYYY"
                  @input="() => {onSelectDateRange(); $refs.qStartDateProxy.hide()}"
                />
              </q-popup-proxy>
            </q-icon>
          </template>
        </q-input>
        <q-input
          v-model="dateRange[1]"
          dense
          outline
          debounce="300"
          mask="##/##/####"
          placeholder="Đến ngày"
          style="width: 120px"
          @input="onSelectDateRange"
        >
          <template v-slot:append>
            <q-icon name="event" class="cursor-pointer">
              <q-popup-proxy ref="qEndDateProxy" transition-show="scale" transition-hide="scale">
                <q-date
                  v-model="dateRange[1]"
                  mask="DD/MM/YYYY"
                  @input="() => {onSelectDateRange(); $refs.qEndDateProxy.hide()}"
                />
              </q-popup-proxy>
            </q-icon>
          </template>
        </q-input>
      </template>
    </q-table>
  </div>
</template>

<script>
import _get from 'lodash/get';
import moment from 'moment';
import { mapActions, mapGetters } from 'vuex';

export default {
  props: {
    isOwner: { type: Boolean, default: false }
  },
  data() {
    return {
      dateRange: [],
      columns: [
        {
          name: 'id',
          label: 'STT',
          align: 'left',
          field: 'id',
          sortable: true
        },
        {
          name: 'date',
          label: 'Ngày',
          align: 'left',
          field: 'date',
          sortable: true
        },
        {
          name: 'sku',
          label: 'Mã sản phẩm',
          align: 'left',
          field: 'product',
          format: val => (val ? val.sku : ''),
          sortable: true
        },
        {
          name: 'name',
          label: 'Tên sản phẩm',
          align: 'left',
          field: 'product',
          format: val => (val ? val.name : ''),
          sortable: true
        },
        {
          name: 'totalSold',
          label: 'Tổng số lượng bán trong ngày',
          align: 'left',
          field: 'totalSold',
          sortable: true
        },
        {
          name: 'category',
          label: 'Danh mục',
          align: 'left',
          field: 'product',
          format: val => _get(val, 'category.name', ''),
          sortable: true
        },
        {
          name: 'brand',
          label: 'Nhãn hàng',
          align: 'left',
          field: 'product',
          format: val => _get(val, 'brand.name', ''),
          sortable: true
        }
      ]
    };
  },
  computed: {
    ...mapGetters({
      orderReports: 'reports/getOrderReports'
    })
  },
  mounted() {
    this.getOrderReports({ isOwner: this.isOwner });
  },
  methods: {
    ...mapActions({
      getOrderReports: 'reports/getOrderReports'
    }),
    onSelectDateRange() {
      let dateRange = this.dateRange
        .map(date => moment(date, 'DD/MM/YYYY').format('YYYY-MM-DD'))
        .filter(date => date && date !== 'Invalid date');

      if (dateRange.length < 2) {
        dateRange = [];
      }

      this.getOrderReports({ dateRange, isOwner: this.isOwner });
    }
  }
};
</script>

<style lang="scss" scoped>
.data-table {
  /deep/ th {
    color: $primary;
    opacity: 1;
    font-weight: bold;
    font-size: 0.9rem;
  }
}
</style>
